#pragma once

#include "../physics/component_physics.h"

static const f32 COMPONENT_CAMERA_FOCUS_VELOCITY_MULTIPLIER = 10.0f;
static const f32 COMPONENT_CAMERA_FOCUS_VELOCITY_ZOOM_MULTIPLIER = 0.1f;
static const f32 COMPONENT_CAMERA_FOCUS_ZOOM_MAX = 0.40f;
static const f32 COMPONENT_CAMERA_FOCUS_ZOOM_MIN = 0.25f;

typedef struct ComponentCameraFocus
{
	Component component;
	Camera* camera;
	EntityID entityID;
} ComponentCameraFocus;

void component_camera_focus_tick(ComponentCameraFocus* self, ECS* ecs);

void
component_camera_focus_init
(
	ComponentCameraFocus* self, 
	ECS* ecs,
	Camera* camera,
	EntityID entityID
);

static const ComponentInfo COMPONENT_CAMERA_FOCUS_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_camera_focus_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_CAMERA_FOCUS,
	.size = sizeof(ComponentCameraFocus)
};
