#include "ending.h"

void
ending_init(Ending* self, ECS* ecs)
{
	memset(self, '\0', sizeof(Ending));

	self->ecs = ecs;

	self->cursor = entity_cursor_add(self->ecs);

	self->text = entity_text_add
	(
		ecs,
		&ecs->resources->fonts[FONT_BIG], 
		RENDERER_BUFFER_UI,
		STRING_ENDING_TEXT,
		ENDING_TEXT_POSITION,
		-1
	);

	self->bg = entity_sprite_add
	(
		ecs, 
		&ecs->resources->textures[TEXTURE_ENDING],
		RENDERER_BUFFER_BACKGROUND, 
		ORIGIN_TOP_LEFT,
		ENDING_BG_SIZE,
		ENDING_BG_POSITION
	);

	music_play(&self->ecs->resources->music[MUSIC_VICTORY], true);
}

void
ending_tick(Ending* self)
{
	if (self->isFinished)
		return;

	if (control_released(self->ecs->control, CONTROL_ACTION_PRIMARY))
		self->isFinished = true;
}

void
ending_free(Ending* self)
{

}

